#pragma once

namespace AMDiS
{
  template <class GridView, class Element, class Operators, class ElementAssembler>
  void assembleOperators(
      GridView const& gridView,
      Element const& element,
      Operators& operators,
      ElementAssembler const& localAssembler)
  {
    // assemble element operators
    localAssembler(element, operators.onElement());

    // assemble intersection operators
    if (!operators.onIntersection().empty()
        || (!operators.onBoundary().empty() && element.hasBoundaryIntersections()))
    {
      for (auto const& intersection : intersections(gridView, element)) {
        if (intersection.boundary())
          localAssembler(intersection, operators.onBoundary());
        else
          localAssembler(intersection, operators.onIntersection());
      }
    }
  }

} // end namespace AMDiS
